<copyright> DoubleArray class.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 2000 Pieter J. Schoenmakers.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: DoubleArray.t,v 1.2 2000/05/13 08:27:44 tiggr Exp $</id>
    </copyright>

implementation class 
DoubleArray : Array

<doc> Take the {double} arguments and craft a new array.  </doc>
extern instance (id) with dynamic elements;

end;

implementation instance 
DoubleArray

protected extern id
  initWithEnumerator Enumerator e;

Any 
  at int index
{
  double d = self[index];
  = Any ([DoubleNumber with d]);
}

byte 
  at int index
{
  double d = self[index];
  = byte (d);
}

char
  at int index
{
  double d = self[index];
  = char (d);
}

extern double 
  at int index;

long 
  at int index
{
  float f = self[index];
  = long (f);
}

int 
  at int index
{
  float f = self[index];
  = int (f);
}

float 
  at int index
{
  double d = self[index];
  = float (d);
}

extern int 
  elementByteSize;

//extern int hash;

extern (pointer, int)
  pointerToElements (int, int) (start, len);

/******************** copying ********************/

<doc> Return the {MutableDoubleArray} class.  </doc>
class (State)
  mutableCopyClass
{
  = [MutableDoubleArray self];
}

end;

