<copyright> FloatArray class.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 2000 Pieter J. Schoenmakers.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: FloatArray.t,v 1.2 2000/05/13 08:27:44 tiggr Exp $</id>
    </copyright>

implementation class 
FloatArray : Array

<doc> Take the {float} arguments and craft a new array.  </doc>
extern instance (id) with dynamic elements;

end;

implementation instance 
FloatArray

protected extern id initWithEnumerator Enumerator e;

Any 
  at int index
{
  float f = self[index];
  = Any ([FloatNumber with f]);
}

byte 
  at int index
{
  float f = self[index];
  = byte (f);
}

char
  at int index
{
  float f = self[index];
  = char (f);
}

extern float 
  at int index;

long 
  at int index
{
  float f = self[index];
  = long (f);
}

int 
  at int index
{
  float f = self[index];
  = int (f);
}

double 
  at int index
{
  float f = self[index];
  = double (f);
}

extern int 
  elementByteSize;

// extern int hash;

extern (pointer, int)
  pointerToElements (int, int) (start, len);

/******************** copying ********************/

<doc> Return the {MutableFloatArray} class.  </doc>
class (State)
  mutableCopyClass
{
  = [MutableFloatArray self];
}

end;

