<copyright> HeapElement class.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1997, 2000 Pieter J. Schoenmakers.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: HeapElement.t,v 1.6 2000/04/20 20:58:00 tiggr Exp $</id>
    </copyright>

implementation class
HeapElement: State, Comparable

end;

implementation instance
HeapElement
{
  <doc> The index of the element within the {Heap} it is stored.  This
      index is 1 more than the index in the {elements} {Array} of the
      {Heap}.  If this element is not part of a heap, this index is 0.
      </doc>
  int heap_index;
}

<doc> Set the {heap_index} to {index}, without checking the {heap}.
    </doc>
void
  set_index int index
    in_heap Heap heap
{
  heap_index = index;
}

<doc> Return the {heap_index}, assuming a correct {heap}.  </doc>
int
  index_in_heap Heap heap
{
  = heap_index;
}


end;
